
function Elem_in_tb(elem,tb)
  local found
  for eit = 1, #tb do if tb[eit] == elem then found = 1 break end end
  return found
end
local items = reaper.CountSelectedMediaItems()
if items == 0 then return end
reaper.Undo_BeginBlock()
reaper.PreventUIRefresh(1)
for i = items-1,0,-1 do
  local item = reaper.GetSelectedMediaItem(0,i)
  local t = {}
  if item then
    local take = reaper.GetActiveTake(item)
    if take then
      if reaper.TakeIsMIDI(take) then
        local _, notes = reaper.MIDI_CountEvts(take)
        for i = 0, notes - 1 do
          local start_note = ({reaper.MIDI_GetNote(take, i)})[4]
          local start_note = reaper.MIDI_GetProjTimeFromPPQPos(take, start_note)
          if not Elem_in_tb(start_note,t) then
            t[#t+1] = start_note
          end
        end
        for i = 2, #t do item = reaper.SplitMediaItem(item, t[i]) end
      end
    end
  end
end
reaper.UpdateArrange()

reaper.PreventUIRefresh(-1)
reaper.Undo_EndBlock('Split MIDI item at notes starts', -1)
